@inject Observatory obz
@inject Backend back
@implements IDisposable

<div class="custom-scroller" style="width: 100%; height: 100%; max-height: 50vh;">
<div class="card shadow-sm" style="padding: 0; width: 100%; overflow-y: auto; height: 100%;">
    <ul class="list-group">
        <li class="list-group-item list-group-item-primary">@if(GameStatus=="LOBBY"){
            <span>Players</span>}else{<span>Rankings</span>}
        </li>
        @foreach(var playerRanking in PlayerRankings){
            <li class="@GetPlayerItemClasses(playerRanking)">@if(GameStatus!="LOBBY"){<span>@(displayRanking(playerRanking.nick)):</span>}
                <b>@playerRanking.nick</b>@if(playerRanking.host && GameStatus!="COMPLETED"){<sup>Host</sup>}
            @if(GameStatus!="LOBBY"){<span> - @playerRanking.points</span>}</li>
        }
    </ul>
</div>
</div>

@code {

    [Parameter]
    public string GameStatus {get;set;}

    [Parameter]
    public List<PlayerRanking> PlayerRankings {get;set;}

    private string GetPlayerItemClasses(PlayerRanking ranking){
        return "list-group-item" + (ranking.connected ? "" : " disabled");
    }

    private string displayRanking(string nick){
        int rank = calcRanking(nick);
        if (rank>=10 && rank<=20) return $"{rank}th";
        
        string digit = rank.ToString().Substring(rank.ToString().Length-1);
        if (digit=="1") return $"{rank}st";
        if (digit=="2") return $"{rank}nd";
        if (digit=="3") return $"{rank}rd";

        return $"{rank}th";
    }

    private int calcRanking(string nick){
        int rank = 0;
        int lastPoints = -1;
        for(int i = 0; i < PlayerRankings.Count(); i++){
            //Console.WriteLine($"i{i} pts{PlayerRankings[i].points} lst{lastPoints} r{rank}");
            if (lastPoints == -1 || PlayerRankings[i].points < lastPoints){
                rank++;
                lastPoints = PlayerRankings[i].points;
            }
            if (PlayerRankings[i].nick == nick)
                return rank;
        }
        return -1;
    }

    protected override void OnInitialized(){
        obz.Register<PlayerJoinMessage>("PLAYER_JOIN", OnPlayerJoin, "RankingsComponent");
        obz.Register<PlayerLeftMessage>("PLAYER_LEFT", OnPlayerLeave, "RankingsComponent");
        obz.Register<NewHostMessage>("NEW_HOST", OnNewHost, "RankingsComponent");
    }

    private void OnPlayerJoin(PlayerJoinMessage msg){
        var nick = msg.data.nick;
        var playerAlreadyRegistered = false;
        foreach(PlayerRanking ranking in this.PlayerRankings){
            if (ranking.nick == nick){
                ranking.connected = true;
                playerAlreadyRegistered = true;
                break;
            }
        }
        if (!playerAlreadyRegistered){
            PlayerRankings.Add(new PlayerRanking(nick));
        }
        obz.Notify("toast", new ToastData($"{nick} has connected"));
        base.StateHasChanged();
    }
    private void OnPlayerLeave(PlayerLeftMessage msg){
        var nick = msg.data.nick;
        foreach(PlayerRanking ranking in this.PlayerRankings){
            if (ranking.nick == nick){
                ranking.connected = false;
                break;
            }
        }
        obz.Notify("toast", new ToastData($"{nick} has disconnected"));
        base.StateHasChanged();
    }
    private void OnNewHost(NewHostMessage msg){
        var nick = msg.data.nick;
        foreach(PlayerRanking ranking in this.PlayerRankings){
            if (ranking.nick == nick){
                ranking.host = true;
            }else{
                ranking.host = false;
            }
        }
        var whoPhrase = nick == back.GetPlayerNick() ? "You are" : $"{nick} is";
        obz.Notify("toast", new ToastData($"{whoPhrase} now the game host"));
        base.StateHasChanged();
    }

    public void Dispose(){
        obz.Deregister("RankingsComponent");
    }

}